
  PROGRAM

  MAP
AnyTabProc PROCEDURE   
  END
INCLUDE('KeyCodes.clw')
INCLUDE('AnyScreen.inc')

  CODE
  AnyTabProc 

AnyTabProc PROCEDURE
LQ         QUEUE         !$ List 
Id           LONG
Str          STRING(30)
Mark         BYTE                           !Entry's marked status
ViewPosition STRING(1024)                   !Entry's view position
           END           
CQ         QUEUE         !$ Combo
Str          STRING(30)
Id           LONG
           END 
           
ICON:Ok     EQUATE('~Ok.ico')       
ICON:Cancel EQUATE('~Cancel.ico')  

lCheck      BYTE(False)  
lQuantity   LONG(1)
lAmount     DECIMAL(9.2)
lTotal      DECIMAL(9.2)
         
TheWindow WINDOW('Tab Window Caption'),AT(,,252,146),CENTER,GRAY,FONT('Segoe UI',10)
          BOX,AT(1,1,250,122),USE(?BOX),COLOR(COLOR:Black),LINEWIDTH(1)
                    PROMPT('&String Entry:'),AT(10,10),USE(?PROMPT:EntryStr)
                    ENTRY(@s30),AT(60,10,120,10),USE(?ENTRY:String),IMM,FLAT
                    PROMPT('&Amount:'),AT(10,24),USE(?PROMPT:EntryAmt)
                    ENTRY(@n$13.2),AT(60,24,60,10),USE(lAmount,, ?ENTRY:Amount),IMM, |
                              FLAT
                    PROMPT('&Quantity:'),AT(10,38),USE(?PROMPT:Qty)
                    SPIN(@n2),AT(60,38,40,10),USE(lQuantity,, ?SPIN:Qty),IMM,FLAT, |
                              HSCROLL,REQ
                    PROMPT('Total:'),AT(10,52),USE(?PROMPT:Total)
                    ENTRY(@n$13.2),AT(60,52,60,10),USE(lTotal,, ?ENTRY:Total),IMM,SKIP, |
                              FLAT,COLOR(COLOR:BTNFACE),READONLY
          BUTTON('&OK'),AT(130,124,60,20),USE(?BTN:Ok),LEFT
          BUTTON('&Cancel'),AT(191,124,60,20),USE(?BTN:Cancel),LEFT
     END
     
  CODE 
  AnyScreen:Init()
  OPEN(TheWindow)
  DO InitControlProperties
  ACCEPT
    CASE EVENT()
    OF EVENT:Selected
      DO SetSelected
    OF EVENT:NewSelection
      CASE FIELD()
      OF ?SPIN:Qty
        DO UpdateTotal 
      END
    OF EVENT:Accepted
      CASE ACCEPTED()
      OF ?ENTRY:Amount OROF ?SPIN:Qty
        DO UpdateTotal
      OF ?BTN:Ok OROF ?BTN:Cancel
        BREAK
      END  
    END  
    DO SetControlProperties
  END 
  CLOSE(TheWindow)
  AnyScreen:Kill()  
  RETURN

SetSelected ROUTINE
  Sel# = SELECTED()
  CASE Sel#{PROP:Type}
  OF CREATE:Text
    Type" = 'Text'
  OF CREATE:Entry
    Type" = 'Entry'
  OF CREATE:Spin
    Type" = 'Spin'
  OF CREATE:Combo
    Type" = 'Combo'
  OF CREATE:List  
    Type" = 'List'
  ELSE
    Type" = Sel#{PROP:Text}
  END  
        
SetControlProperties ROUTINE 
  0{PROP:Text} = 'Sel=' & Sel# & '/' & Type"

UpdateTotal ROUTINE
  lTotal = lQuantity * lAmount 
  DISPLAY(?ENTRY:Total)
  
InitControlProperties ROUTINE
  ?BTN:Ok{PROP:Icon} = ICON:Ok
  ?BTN:Cancel{PROP:Icon} = ICON:Cancel

    